#include "scr_Dictionary.h"

scr_Dictionary::scr_Dictionary(char* filename){
ifstream indexer(filename,ios::in|ios::bin);
unsigned long int size,count=0;
 indexer.read((char *)&size, 4);
 start=size-1;
 index = new unsigned long int[size];
 while(!indexer.eof()){
  indexer.read((char *)&index[count], 4);
  count++;
 }
}

scr_Dictionary::~scr_Dictionary(){
 delete[] index;
}

//tells a letter available to jump to, and returns stuff necessary to get to that point
//stuff:
//1-5: position in pointers/headers

inline char scr_Dictionary::GetSequence(unsigned long int stuff, unsigned char* build){
char a=1,b=0;
 build[0]=Letter(stuff);
 if(IsTrailer(stuff)){
  unsigned long int temp=1;
  for(a=1;temp;a++,temp>>=5){
   if(a%6==1){
    temp=index[Jump(stuff)+b];
    b++;
   }
   build[a]=temp&31;
  }
 }
 build[a]='\0';
 return b;
}


char scr_Dictionary::Verify(char* input){
unsigned long int search=Jump(Start());
 if(PushString(input,search)){
  return(AreWords(search));
 }
 else return 0;
}


/*
unsigned long int bum=Start();
char a,b=0,c[20],d,m=0,q=1;
 bum=Jump(bum);
 while(input[b]&&q){
  m=AreWords(bum);
  q=IsNextPointer(bum);
  d=GetSequence(bum,c);
  for(a=0;(input[b]==c[a])&&input[b];a++,b++);
  if(a){
   if(c[a]) break;
   else{
    q=ArePointers(bum);
    bum=Jump(bum)+d;
   }
  }
  else bum++;
 }
 if(input[b]||c[a]) return 0;
 else if(m) return 1;
}
*/

//point needs to be pointing to the first pointer of a sequence that PushString will try
char scr_Dictionary::PushString(char* input, unsigned long int& point){
unsigned char a=0,b=0,c[20],d,r=1;
 c[0]=0;
 while(r&&input[b]&&(input[b]>=Letter(point))){
  r=IsNextPointer(point);
  if(input[b]==Letter(point)){
   d=GetSequence(point,c);
   for(a=0;(input[b]==c[a])&&input[b];a++,b++);
   if(a){
    if(c[a]) break;
    else if(input[b]){
     r=ArePointers(point);
     point=Jump(point)+d;
    }
   }
  }
  else point++;
 }
 if(input[b]||c[a]){
  return 0;
 }
 else return 1;
}

unsigned long int scr_Dictionary::Bridge(char* fore, char* aft){
unsigned long int point=Start(),travel,out=0;
char copy[15];
 if(fore[0]) point=Jump(point);
 if(PushString(fore,point)){
  if(ArePointers(point)){
   char q;
   for(q=0;aft[q];q++) copy[q+1]=aft[q];
   copy[q+1]='\0';
   q=IsTrailer(point);
   point=Jump(point);
   if(q){
    while(Raw(point)&(1<<31)) point++;
    point++;
   }
   do{
    q=IsNextPointer(point);
    travel=point;
    copy[0]=Letter(point);
    if(PushString(copy,travel)){
     if(AreWords(travel)) out+=(1<<(copy[0]-1));
    }
    point++;
   }while(q);
  }
 }
 return(out);
}















